-- Extra hooks for extra events

-- Taken from libsg2 in ringracers-scripts
local hooks = {}
rawset(_G, "SG_RegisterHook", function(name)
	hooks[name] = {}
end)
rawset(_G, "SG_AddHook", function(name, func)
	table.insert(hooks[name], { func = func })
end)
rawset(_G, "SG_RunHook", function(name, ...)
	for i, hook in ipairs(hooks[name]) do
		hook.func(...)
	end
end)

-- Hook format: function(player_t victim, int itemtype, int itemcount)
SG_RegisterHook("ItemLost")

addHook("PlayerThink", function(p)
    if p.sg_itemtype == nil then
        p.sg_itemtype = p.kartstuff[k_itemtype]
        p.sg_itemamount = p.kartstuff[k_itemamount]
        p.sg_itemheld = p.kartstuff[k_itemheld]
    end

    if p.cmd.buttons & BT_ATTACK then
        p.sg_itemuse = ($ or 0) + 1
    else
        p.sg_itemuse = 0
    end

    if p.sg_itemtype ~= 0 and p.kartstuff[k_itemtype] == 0 and not (p.sg_itemuse == 1) and not p.sg_itemheld then
        SG_RunHook("ItemLost", p, p.sg_itemtype, p.sg_itemamount)
    end

    p.sg_itemtype = p.kartstuff[k_itemtype]
    p.sg_itemamount = p.kartstuff[k_itemamount]
    p.sg_itemheld = p.kartstuff[k_itemheld]
end)

addHook("MapLoad", function()
    for p in players.iterate do
        p.sg_itemtype = nil
        p.sg_itemamount = nil
        p.sg_itemheld = nil
        p.sg_itemuse = nil
    end
end)
