local SF_FLIPSPECIAL_FLOOR = 1
local SF_FLIPSPECIAL_CEILING = 2
local SF_FLIPSPECIAL_BOTH = 3
local SF_TRIGGERSPECIAL_TOUCH = 4

local sectorflags = {}

local SF_DEFAULT = SF_FLIPSPECIAL_FLOOR

addHook("MapLoad", function(mapid)
    sectorflags = {}

    for line in lines.iterate do
        if line.special == 8 then
            local flags = SF_DEFAULT

            if line.flags & ML_NOCLIMB then
                flags = $ & ~SF_FLIPSPECIAL_FLOOR
                flags = $ | SF_FLIPSPECIAL_CEILING
            elseif line.flags & ML_EFFECT4 then
                flags = $ | SF_FLIPSPECIAL_BOTH
            end

            if line.flags & ML_EFFECT3 then
                flags = $ | SF_TRIGGERSPECIAL_TOUCH
            end

            sectorflags[line.tag] = flags
        end
    end
end)

addHook("NetVars", function(net)
    sectorflags = net($)
end)

local function getSectorFlags(tag)
    if sectorflags[tag] == nil then return SF_DEFAULT end

    return sectorflags[tag]
end

local function floorIsTrigger(tag)
    return getSectorFlags(tag) & SF_FLIPSPECIAL_FLOOR
end

local function ceilingIsTrigger(tag)
    return getSectorFlags(tag) & SF_FLIPSPECIAL_CEILING
end

rawset(_G, "SF_FLIPSPECIAL_FLOOR", SF_FLIPSPECIAL_FLOOR)
rawset(_G, "SF_FLIPSPECIAL_CEILING", SF_FLIPSPECIAL_CEILING)
rawset(_G, "SF_FLIPSPECIAL_BOTH", SF_FLIPSPECIAL_BOTH)
rawset(_G, "SF_TRIGGERSPECIAL_TOUCH", SF_TRIGGERSPECIAL_TOUCH)

rawset(_G, "SG_GetSectorFlags", getSectorFlags)
rawset(_G, "SG_FloorIsTrigger", floorIsTrigger)
rawset(_G, "SG_CeilingIsTrigger", ceilingIsTrigger)
