local function getVar(name)
    local var = CV_FindVar(name) or { value = 0 }

    return var.value
end

local function updateGamemodes()
    if not (isserver and not replayplayback) then return end

    local file, err = io.open("gamemodefile.txt", "w")

    if not file then
        print("\x82WARNING:\x80 failed to open gamemodes file: "..err)
        return
    end

    local gamemodes = {}

    -- driftnitro already activates tech, so only display one at the time
    if getVar("driftnitro") then
        table.insert(gamemodes, "Drift Nitro")
    elseif getVar("juicebox") then
        table.insert(gamemodes, getVar("juicebox") == 2 and "Tech" or "Juicebox Tech")
    end

    if getVar("rebasics") then
        table.insert(gamemodes, "ReBasics")
    elseif getVar("as_active") == 0 then -- Enabled by default, can be voted off
        table.insert(gamemodes, "No Acrobasics")
    end

    if getVar("elimination") then
        table.insert(gamemodes, "Elimination")
    end

    if getVar("hpmod_enabled") then
        table.insert(gamemodes, "HP Mod")
    end

    if getVar("allrestat") then
        table.insert(gamemodes, "Random Stats")
    end

    if getVar("weathermod") then
        table.insert(gamemodes, "Weathermod")
    end

    if getVar("fr_enabled") then
        table.insert(gamemodes, "Friendmod")
    end

    if getVar("combi_active") then
        table.insert(gamemodes, "Combi")
    end

    if getVar("rings") then
        table.insert(gamemodes, "Rings")
    end

    file:write(table.concat(gamemodes, "\n"))
    file:close()
end

addHook("MapLoad", updateGamemodes)
