-- a hacky edit of quantum jawz code by retrostation
-- Fixed up and improved by Indev for Sunflower's Garden
-- v5: SPB is now coloured based on the colour of the owner who shot it, with a cute easter egg in a curtain condition
-- v6: Moved SPB colouring to a different lua
-- v7: (no different filename) - now basically only teleports behind player when close enough to avoid frontspb
rawset(_G, "spbwarp" , CV_RegisterVar({
    name = "spbwarp",
    defaultvalue = "On",
    flags = CV_NETVAR,
    PossibleValue = CV_OnOff,
}))

local MAXDIST = 3072

local function BlueShell(actor)
    if spbwarp.value then
        if actor.tracer and actor.tracer.valid and actor.tracer.player then
            local pmo = actor.tracer
            local spbDistFixed = FixedHypot(pmo.x - actor.x, pmo.y - actor.y)
            --Shoutouts to SPB Attack math
            local spbDist = (spbDistFixed - actor.radius) / mapobjectscale

            -- Target switched, don't teleport
            if actor.warptracer ~= nil and actor.warptracer ~= pmo then
                actor.warptracer = nil
            end

            -- If target has changed, don't forcewarp to it (rare edge case but still possible)
            if actor.forcewarp and actor.warptracer ~= pmo then
                actor.forcewarp = false
            end

            if spbDist > MAXDIST and not actor.forcewarp then
                actor.forcewarp = actor.warptracer == pmo -- In case same targeted player gets teleported, we re-trigger spb warp
                return -- Don't set lastSpbDist pls
            elseif actor.warptracer ~= pmo or actor.forcewarp then
                actor.warptracer = pmo

                local forcewarp = actor.forcewarp
                actor.forcewarp = false

                -- If forcewarp is true and lastSpbDist is nil somehow, will still pick 1500
                local zipdist = min(forcewarp and actor.lastSpbDist or 1500, MAXDIST)

                local speed = FixedHypot(pmo.momx, pmo.momy)
                local dirx, diry

                -- Avoid zero division
                if speed ~= 0 then
                    -- Teleport spb behind player based on their movement direction
                    dirx = FixedDiv(pmo.momx, speed)
                    diry = FixedDiv(pmo.momy, speed)
                else
                    -- Teleport spb based on look angle
                    dirx = cos(pmo.angle)
                    diry = sin(pmo.angle)
                end

                if not forcewarp then
                    local spbdirx, spbdiry = FixedDiv(actor.x - pmo.x, spbDistFixed), FixedDiv(actor.y - pmo.y, spbDistFixed)

                    local dot = FixedMul(dirx, spbdirx) + FixedMul(diry, spbdiry)

                    -- SPB is behind player, no need to warp
                    if dot < 0 then return end
                end

                local zip = zipdist*mapobjectscale
                local offzet = FixedMul(pmo.height, mapobjectscale)

                P_MoveOrigin(actor, pmo.x - FixedMul(zip, dirx), pmo.y - FixedMul(zip, diry), pmo.z + offzet)

                -- Reset speed and angle to face new direction
                local speed = FixedHypot(actor.momx, actor.momy)

                actor.momx = FixedMul(dirx, speed)
                actor.momy = FixedMul(diry, speed)

                actor.angle = R_PointToAngle2(0, 0, dirx, diry)
            end

            actor.lastSpbDist = spbDist
        end
    end
end
addHook("MobjThinker", BlueShell, MT_SPB)
