-- command definitions etc

rawset(_G, "kmp", "R1.5")
rawset(_G, "kmp_prerelease", 0)		-- don't let that in the release, doofus.

rawset(_G, "kmp_hyudoro", CV_RegisterVar({
  name = "kmp_hyudoro",
  defaultvalue = "Off",
  flags = CV_NETVAR,
  PossibleValue = CV_OnOff,
}))

rawset(_G, "kmp_haste", CV_RegisterVar({
  name = "kmp_haste",
  defaultvalue = "Off",
  flags = CV_NETVAR,
  PossibleValue = CV_OnOff,
}))

-- return splitflags in function of splitscreen status
rawset(_G, "FUCK_returnsplitflags", function(f, displaynum)

	if not splitscreen return f end

	-- exhibit 1: 2p
	if splitscreen == 1
		if not displaynum -- p1
			return f & ~(V_SNAPTOBOTTOM)
		else	-- p2
			return (f|V_SPLITSCREEN) & ~(V_SNAPTOTOP)
		end
	else
		-- jesus fuck this sucks dicks
		if not displaynum	-- p1
			return f & ~(V_SNAPTOBOTTOM|V_SNAPTORIGHT)
		elseif displaynum == 1	-- p2
			return (f|V_HORZSCREEN) & ~(V_SNAPTOBOTTOM|V_SNAPTOLEFT)
		elseif displaynum == 2	-- p3
			return (f|V_SPLITSCREEN) & ~(V_SNAPTOTOP|V_SNAPTORIGHT)
		elseif displaynum == 3	-- p4
			return (f|V_SPLITSCREEN|V_HORZSCREEN) & ~(V_SNAPTOTOP|V_SNAPTOLEFT)
		end
	end
	return f	-- shouldn't happen but don't return nil either way lol
end)

local dispinfo = {
	{"Extended Hyudoro", kmp_hyudoro},
	{"Driftboost Adjust (Haste)", kmp_haste},
}

COM_AddCommand("kmp_info", function(p)

	if kmp_prerelease
		CONS_Printf(p, "\x82".."KMP PRERELEASE "..kmp.." || DO NOT REDISTRIBUTE")
	else
		CONS_Printf(p, "\x82".."Running KMP "..kmp)
	end
	CONS_Printf(p, "List of parameters:")
	for i = 1, #dispinfo
		local info = dispinfo[i]
		local clr = info[2].value and "\x83".."ON " or "\x85".."OFF"

		CONS_Printf(p, clr.."\x80 - ".."\x82"..info[2].name.."\x80"..": ("..info[1]..")")
	end
	CONS_Printf(p, "Type \'kmp_help <command name>\' for more details about the above commands")
end)

local help = {
	{"Doubles Hyudoro's duration and makes Jawz lose sight of you when used.", kmp_hyudoro},
	{"Longer drift boosts for lower speed stats.", kmp_haste},
}

COM_AddCommand("kmp_help", function(p, arg)

	if not arg return end	-- morron
	arg = arg:lower()

	for i = 1, #help
		if arg == help[i][2].name
			CONS_Printf(p, "\x82"..help[i][2].name.."\x80"..":\n"..help[i][1])
			return
		end
	end
	CONS_Printf(p, "No command named \'"..arg.."\' in KMP. Use \'kmp_info\' to view a list of all the commands")
end)
