-- this script attempts to make Kart more playable in Multiplayer when too many people are around by disabling some items and doing other stuff as the playercount increases
-- everything in this script is LOL XD! By VincyTM
-- Kanade is the most precious girl out there.

--local dbg_amount = 5

local kmp_bumpspark
local kmp_hyudoro = kmp_hyudoro
local kmp_haste = kmp_haste

local kmp_hyudoro_active = 0

local function bumpsparkLookup()
    kmp_bumpspark = 0

    -- Reimplementation with builtin bumpspark nerf and 1 annoying feature removed
    local cv = CV_FindVar("bonkspark")
    if cv then kmp_bumpspark = kmp_bumpspark or cv.value end
end

addHook("MapLoad", bumpsparkLookup)
addHook("NetVars", bumpsparkLookup)

addHook("MapLoad", function()
    kmp_hyudoro_active = kmp_hyudoro.value
end)

addHook("NetVars", function(net)
    kmp_hyudoro_active = net($)
end)

-- I hate this
local k_offroad = k_offroad
local k_driftboost = k_driftboost
local k_driftcharge = k_driftcharge
local k_spinouttimer = k_spinouttimer
local k_squishedtimer = k_squishedtimer
local k_drift = k_drift
local BT_DRIFT = BT_DRIFT
local MFE_JUSTBOUNCEDWALL = MFE_JUSTBOUNCEDWALL
local FRACUNIT = FRACUNIT
local max = max

-- Thats just constant, why re-evaluate that every frame?
--
-- Figure out how strong we're proportionally boosting MTs.
local bonusfactor = FixedDiv((130 - 100)*FRACUNIT, 100*FRACUNIT)

local function K_hasteClear(p)
    local ks = p.kartstuff

    p.NAlastdriftboost = ks[k_driftboost]
	p.NAlastdriftcharge = ks[k_driftcharge]
	p.NAlastdrift = ks[k_drift]
	p.NAlastbuttons = p.cmd.buttons & BT_DRIFT
	p.NAlastbounced = p.mo.eflags & MFE_JUSTBOUNCEDWALL
	p.NAlastadjust = $ or 0

	if kmp_bumpspark then
		p.NAlastbounced = 0	-- that never happened!
	end
end

-- Credits to Tyron for the original Haste script
local function K_handleHaste(p)
	if not kmp_haste.value then return end
	local mo = p.mo
	if not mo then return end

    local ks = p.kartstuff

	if p.NAlastdriftboost ~= nil then

		-- This is a sort of roundabout way of detecting drifts, but we can't rely on adjustments to k_driftboost alone...
		-- If we're a 1 speed character, a blue MT should boost us from 20F to 26F by default.
		-- However, if we chain a red into a blue with 23F left on the timer, the game will ignore it!
		-- This is because the base value of a blue MT, 20F, is less than the value we currently have...
		-- ...so in the base game, applying that MT would actually slow us down, even though Haste would boost it up again!
		if p.NAlastdriftcharge > ks[k_driftcharge] then
			-- Our goal is to detect an MT one frame after it's happened, then retroactively apply the bonus time.
			local accel = max(0, (9 - p.kartspeed - p.kartweight/2))
			local target = (26*4 + p.kartspeed*2)*8 -- Taken from source.
			local LDC = p.NAlastdriftcharge
			local fakecharge = 20 -- Taken from source.
			--local fakename = "blue"
			-- This is a bunch of redundant safety conditions because I'm kinda paranoid.
			-- At least the most common ones are at the top.
			if p.NAlastbounced
                or ks[k_driftboost] < 19
                or p.speed <= 10*FRACUNIT
			    or ks[k_spinouttimer]
			    or ks[k_squishedtimer]
                or LDC < target
			    or p.NAlastbuttons then

                K_hasteClear(p)

				return
			elseif LDC >= target*4 then -- Rainbow and red MT values taken from source.
				fakecharge = 125
				--fakename = "rainbow"
				-- fallthrough
			elseif LDC >= target*2 then
				fakecharge = 50
				--fakename = "red"
				-- fallthrough
			end

			-- Figure out how much of that bonus a character is eligible for, based on their stats.
			-- 1 speed gets full bonus: 9 speed gets none! (In practice, 7+ speed gets 0F bonuses.)
			local diefactor = FRACUNIT + FixedMul(FixedDiv(bonusfactor, FRACUNIT*8), accel*FRACUNIT)
			-- Calculate the length of the target type of MT with bonus applied...
			-- ...minus 1 for the frame it's already been going.
			local holding = FixedInt(FixedMul(fakecharge*FRACUNIT, diefactor)) - 1
			-- Fixed point math is terrible.
			--dprint(p, "Correcting", fakename.." MT to", holding, "F, would be", p.kartstuff[k_driftboost], "F (scaled by", diefactor, ")")
			p.NAlastadjust = holding - ks[k_driftboost]
			ks[k_driftboost] = max(holding, $)
		end
	end

	K_hasteClear(p)
end



addHook("MobjThinker", function(mo)

	if kmp_hyudoro_active and mo and mo.valid and mo.target and mo.target.valid and mo.target.player
	and mo.target.player.kartstuff[k_hyudorotimer] then	-- !?
		mo.target = nil
	end
end, MT_JAWZ)

local function K_handleHyudoro(p)
	if not kmp_hyudoro_active then return end

    if p.kmp_hyudorotimer ~= nil then
        if p.kmp_hyudorotimer < p.kartstuff[k_hyudorotimer] then
            p.kartstuff[k_hyudorotimer] = $*2
        end
    end

    p.kmp_hyudorotimer = p.kartstuff[k_hyudorotimer]
end

addHook("ThinkFrame", function()
	for p in players.iterate do
		if p.spectator or not p.mo then continue end

		-- player effects:
		K_handleHaste(p)
		K_handleHyudoro(p)

		-- init player to kmp stuff:
		--if not p.kmp_init then
		--	COM_BufInsertText(p, "kmp_info")
		--	if kmp_prerelease then
		--		chatprintf(p, "\x83".."*KartMP Pre-Release "..kmp.."\nDo not redistribute.")
		--	else
		--		chatprintf(p, "\x83".."*Server is running KartMP "..kmp.."\nType \'".."\x82".."kmp_info".."\x83".."\' in the console for details on the settings used.")
		--	end
		--	p.kmp_init = true
		--end
	end
end)

