-- Config file for Sunflower's Garden
local config_path = "SunflowerGarden.cfg"
local server_name = "Sunflower's Garden"

local function loadConfig()
    if replayplayback then return end

    if consoleplayer ~= nil then
        print("Trying to load "..config_path.."...")

        local file = io.open(config_path, "r")

        if not file then
            print(config_path.." not found, generating it")

            file = io.open(config_path, "w")

            if not file then
                print("\130WARNING\128: could not generate "..config_path.." config file")
                return
            else
                file:write("// Config for "..server_name.." server")
                file:close()
                return
            end
        else
            print("File found, executing it...")

            for line in file:lines() do
                COM_BufAddText(consoleplayer, line)
            end

            file:close()
            print("Done!")
        end
    end
end

addHook("PlayerJoin", function(pnum)
    if consoleplayer and pnum == #consoleplayer then
        loadConfig()
    end
end)
