local cv_randommusic = CV_RegisterVar({
    name = "randommusic",
    defaultvalue = "Off",
    possiblevalue = CV_OnOff,
})

local replacemusnamenext = nil
local replacemusname = nil
local replacemusmap = nil

local function getMapMusicList()
    local list = {}

    for i = 1, #mapheaderinfo do
        if mapheaderinfo[i] ~= nil then
            table.insert(list, mapheaderinfo[i].musname)
        end
    end

    return list
end

local function randomizeMusic(mapid)
	local music_list = getMapMusicList()

	replacemusnamenext = music_list[P_RandomRange(1, #music_list)]
end

addHook("ThinkFrame", function()
    if leveltime == 2 then
		randomizeMusic(gamemap)
    end
end)

-- Thats dumb a bit but it keeps music change synced for midjoiners
addHook("NetVars", function(net)
    replacemusname = net($)
    replacemusmap = net($)
    replacemusnamenext = net($)
end)

local recursion = false -- Terrible hack for keepmusic
addHook("MusicChange", function(old, new, mflags, looping, position, prefadems, fadems)
	if not cv_randommusic.value then return end

	if replacemusmap ~= gamemap then
		-- Cannot call P_Random here for synch reasons
		replacemusname = replacemusnamenext
		replacemusmap = gamemap
	end

    -- We keep WAR music >:D
    if replacemusname and new == mapmusname and new:lower() ~= "pizzaw" then
		if not recursion then
			recursion = true
			-- By using tunes we can overwrite mapmusname, which will make saturn's keepmusic... Well, keep replaced music without restarting it at mapload
			COM_BufInsertText(consoleplayer, "tunes "..replacemusname)
			recursion = false
		end

		return replacemusname
	end
end)
