-- Anti lap grief by Indev for Sunflower's Garden
-- Makes people lap(s) behind no longer be able to interract with power items to the ones further ahead
-- Fixes frustrating issues where bad players screw over the good players
-- Or just griefers in general (Garden rarely has those thankfully)
freeslot("sfx_repel")

-- Note: NoCollision makes it activate at all times (even if 2 players are on same lap)
local antilapgrief = { Off = 0, Shield = 1, Repel = 2, NoCollision = 3, }

local cv_antilapgrief = CV_RegisterVar {
    name = "nolapgrief",
    defaultvalue = "Shield",
    possiblevalue = antilapgrief,
    flags = CV_NETVAR,
}

local cv_ignorefinished = CV_RegisterVar {
    name = "nolapgrief_ignorefinished",
    defaultvalue = "On",
    possiblevalue = CV_OnOff,
    flags = CV_NETVAR,
}

local function savePowerItems(player)
    player.restore_invincibility = max(player.kartstuff[k_invincibilitytimer], player.restore_invincibility or 0)
    player.restore_grow = max(player.kartstuff[k_growshrinktimer], player.restore_grow or 0)
end

local function restorePowerItems(player)
    if player.restore_invincibility ~= nil then
        player.kartstuff[k_invincibilitytimer] = player.restore_invincibility
        player.kartstuff[k_growshrinktimer] = player.restore_grow

        P_RestoreMusic(player)

        player.restore_invincibility = nil
        player.restore_grow = nil
    end
end

addHook("PlayerThink", function(player)
    if player.kartstuff[k_spinouttimer] > 0 or player.kartstuff[k_wipeoutslow] > 0 then return end

    restorePowerItems(player)
end)

addHook("MobjDeath", function(pmo)
    if pmo.player and pmo.player.valid then -- Idk if player can be invalid if player leaves game
        pmo.player.restore_invincibility = nil
        pmo.player.restore_grow = nil
    end
end, MT_PLAYER)

local function doAntiLapGrief(player, otherplayer, only_collision)
    local pmo = player.mo
    local pmo2 = otherplayer.mo

    -- Player is invincible, don't care about lapped players
    if player.kartstuff[k_invincibilitytimer] > 0
        or player.kartstuff[k_growshrinktimer] > 0
        or player.powers[pw_flashing] > 0 then return end

    if not only_collision
        and (otherplayer.kartstuff[k_invincibilitytimer] > 0 or pmo2.scale > pmo.scale) then

        -- Grow is a bitch
        if cv_antilapgrief.value == antilapgrief.Shield or pmo2.scale > pmo.scale then
            player.powers[pw_flashing] = 2
        end

        player.nosquish = pmo2.scale > pmo.scale
        K_DoInstashield(player)

        -- Wanted to grief me? I will grief YOU instead >:3
        if cv_antilapgrief.value == antilapgrief.Repel then
            if not otherplayer.powers[pw_flashing] then
                S_StartSound(player.mo, sfx_repel)

                savePowerItems(otherplayer)
                otherplayer.kartstuff[k_invincibilitytimer] = 0
                otherplayer.kartstuff[k_growshrinktimer] = 0
                pmo2.color = otherplayer.skincolor
                P_RestoreMusic(otherplayer)

                K_SpinPlayer(otherplayer, pmo, 1, pmo)
            end

            return pmo2.scale <= pmo.scale
        end

        return false
    end

	-- No colision with lapped players
    if cv_antilapgrief.value ~= antilapgrief.NoCollision then K_DoInstashield(player) end
	return false
end

local function onCollide(pmo, pmo2)
    if not cv_antilapgrief.value then return end -- Don't care if cvar is off
    if not pmo2.player then return end -- Don't care about non-players
    if cv_ignorefinished.value and (pmo.player.exiting or pmo2.player.exiting) then return end -- Bonk players that are finished already

    -- ffs srb2 why do i have to do this
    if pmo.z > pmo2.z+pmo2.height or pmo.z+pmo.height < pmo2.z then return end

    local player = pmo.player
    local otherplayer = pmo2.player

    if otherplayer.laps < player.laps then
        return doAntiLapGrief(player, otherplayer)
    elseif player.laps < otherplayer.laps then
        return doAntiLapGrief(otherplayer, player)
    elseif cv_antilapgrief.value == antilapgrief.NoCollision then
        return doAntiLapGrief(player, otherplayer, true)
    end
end

addHook("MobjCollide", onCollide, MT_PLAYER)
addHook("MobjMoveCollide", function(pmo2, pmo)
    if pmo.player then return onCollide(pmo, pmo2) end
end, MT_PLAYER)

addHook("PlayerSquish", function(player)
    if player.nosquish then
        player.nosquish = false
        return true
    end
end)
