-- fixdropdash.lua by Indev for Sunflower's Garden
-- Allows users to still dropdash even though they land on terrain without airtime

-- :Trollic:
local TICRATE = TICRATE
local BT_ACCELERATE = BT_ACCELERATE
local k_respawn = k_respawn

-- Thanks KK for not exposing this one!!!
local function K_SpawnDashDustRelease(player)
    local travelangle = 0

    if not P_IsObjectOnGround(player.mo) then return end

    if (not player.speed) and (not player.kartstuff[k_startboost]) then return end

    travelangle = player.mo.angle

    if player.kartstuff[k_drift] or player.kartstuff[k_driftend] then
        travelangle = $ - (ANGLE_45/5)*player.kartstuff[k_drift]
    end

    for i = 0, 1 do
        local newx = player.mo.x + P_ReturnThrustX(player.mo, travelangle + ((i & 1) and -1 or 1)*ANGLE_90, FixedMul(48*FRACUNIT, player.mo.scale))
        local newy = player.mo.y + P_ReturnThrustY(player.mo, travelangle + ((i & 1) and -1 or 1)*ANGLE_90, FixedMul(48*FRACUNIT, player.mo.scale))
        local dust = P_SpawnMobj(newx, newy, player.mo.z, MT_FASTDUST)

        dust.target = player.mo
        dust.angle = travelangle - ((i & 1) and -1 or 1)*ANGLE_45
        dust.destscale = player.mo.scale
        P_SetScale(dust, player.mo.scale)

        dust.momx = 3*player.mo.momx/5
        dust.momy = 3*player.mo.momy/5

        K_MatchGenericExtraFlags(dust, player.mo)
    end
end

addHook("MobjThinker", function(pmo)
    if not (pmo.valid and pmo.player) then return end -- :^)

    local player = pmo.player

    -- For cases in which we respawn in air but don't have enough time to activate drop dash
    pmo.sincerespawn = $ or TICRATE/4

    --print(pmo.sincerespawn)

    if player.kartstuff[k_respawn] > 1 then
        if P_IsObjectOnGround(pmo) then
            pmo.fixdropdash = true
        end
        pmo.sincerespawn = 0
    else
        pmo.sincerespawn = $ + 1

        -- If you respawned on ground or didn't physically have ability to hold accel for longer
        -- than TICRATE/4 tics because of bad respawn point, give drop dash boost
        if P_IsObjectOnGround(pmo) and (player.cmd.buttons & BT_ACCELERATE) and (pmo.fixdropdash or (pmo.sincerespawn <= TICRATE/4)) then
            player.kartstuff[k_startboost] = 50
            S_StartSound(pmo, sfx_s23c)
            K_SpawnDashDustRelease(player)

            -- For both cases, only do that once
            pmo.fixdropdash = false
            pmo.sincerespawn = TICRATE/4
        end
    end
end)
