-- Allrestat by Indev for Sunflower's Garden
-- Gives everyone the very same randomized stat each round.
local ALLRESTAT_TIME = TICRATE

local allrestat = {
    active = false,
    speed = -1,
    weight = -1,
}

local cv_allrestat = CV_RegisterVar {
    name = "allrestat",
    defaultvalue = "Off",
    possiblevalue = CV_OnOff,
    flags = CV_NETVAR,
}

addHook("NetVars", function(net)
    allrestat = net($)
end)

addHook("MapLoad", function()
    -- Toggle the funny only on next map
    allrestat.active = cv_allrestat.value ~= 0
end)

addHook("PostThinkFrame", function()
    if not allrestat.active then
        if leveltime == 1 then
            for player in players.iterate do
                -- Normally you can't access spectator's mobj and skin but GenericHeroGuy discovered
                -- this funny trick
                local oldspec = player.spectator

                player.spectator = false

                player.kartspeed = skins[player.mo.skin].kartspeed
                player.kartweight = skins[player.mo.skin].kartweight

                player.spectator = oldspec
            end
        end

        return
    end

    if leveltime == ALLRESTAT_TIME then
        allrestat.speed = P_RandomRange(1, 9)
        allrestat.weight = P_RandomRange(1, 9)

        chatprint(string.format("\140*Everyone is \130%d speed %d weight\140 this round!", allrestat.speed, allrestat.weight))
        S_StartSound(nil, sfx_kc48)
    elseif leveltime > ALLRESTAT_TIME then
        for player in players.iterate do
            player.kartspeed = allrestat.speed
            player.kartweight = allrestat.weight

            -- Shhhhh
            if player.HMRs then
                player.HMRs = nil
                player.HMRw = nil
            end
        end
    end
end)
