-- SPBPity by Indev for Sunflower's Garden
-- Gives a small catch up compensation for receiving a SPB, which is essentially useless for you normally.
-- The compensation is based on your position of firing it (1-3 Sneakers or Rocket Sneakers (pos 10+)), or nothing when fired as first.
local ROCKETSNEAKER_POSITION = 10

local spbthrown

addHook("PreThinkFrame", do spbthrown = false end)

-- PlayerThink runs after the SPB is thrown in K_MoveKartPlayer
addHook("PlayerThink", function(player)
    if spbthrown and not player.kartstuff[k_itemamount] then
        player.kartstuff[k_itemblink] = TICRATE
        local amount, snd, blink

        if player.kartstuff[k_position] >= ROCKETSNEAKER_POSITION then
            player.kartstuff[k_itemtype] = KITEM_ROCKETSNEAKER
            amount = 1
            blink = 2
            snd = sfx_itrolk
        else
            player.kartstuff[k_itemtype] = KITEM_SNEAKER

            if K_IsPlayerLosing(player) and player.kartstuff[k_position] ~= 2 then
                amount = 3
                snd = sfx_itrolk
                blink = 2
            elseif player.kartstuff[k_position] > 2 then
                amount = 2
                snd = sfx_itrolm
                blink = 0
            elseif player.kartstuff[k_position] == 2 then
                amount = 1
                snd = sfx_itroln
                blink = 1
            end
        end

        if amount then
            player.kartstuff[k_itemamount] = amount
            player.kartstuff[k_itemblinkmode] = blink
            S_StartSound(nil, snd, player)
        end
    end
    spbthrown = false
end)

addHook("MobjSpawn", function(mo)
    spbthrown = true
end, MT_SPB)
