local cv_focustime = CV_RegisterVar {
    name = "spb_focustime",
    defaultvalue = 5*TICRATE,
    possiblevalue = CV_Unsigned,
    flags = CV_NETVAR,
}

local function getBestRank()
    local best = #players + 1

    for player in players.iterate do
        if not (player.spectator or player.exiting) and player.kartstuff[k_position] < best then
            best = player.kartstuff[k_position]
        end
    end

    return best
end

addHook("MobjThinker", function(mo)
    local player = mo.tracer and mo.tracer.player

    if mo.extravalue1 == 1 and player ~= nil then
        local bestrank = getBestRank()

        -- Normal extravalue2 gets reset if player is respawning, we want to avoid that so we use a
        -- fake one instead
        if player.kartstuff[k_position] <= bestrank then
            mo.extravalue2 = cv_focustime.value
            mo.fakeextravalue2 = cv_focustime.value
        elseif mo.fakeextravalue2 then
            mo.fakeextravalue2 = max($ - 1, 0)
            mo.extravalue2 = mo.fakeextravalue2
        end
    end
end, MT_SPB)
