-- Draw dot on minimap to show player's look angle

local cv_angledot = CONFIG_RegisterVar({
	name = "minimapangledot",
	defaultvalue = "On",
	possiblevalue = CV_OnOff,

	config_menu = "Other",
	displayname = "Show Angle",
	description = "Show your angle on minimap with a dot."
})

local dot
local cv_small
local cv_hardcode

hud.add(function(v, p)
    if not dot then
        dot = v.cachePatch("ANGDOT")
		cv_small = CV_FindVar("smallminimapplayers") or { value = 0 }
		cv_hardcode = CV_FindVar("showminimapangle") or { value = 0 }
	end

	if not cv_angledot.value then return end -- The dot is disabled
	if cv_hardcode.value then return end -- Hardcoded version is enabled
    if not p.mo then return end -- Don't draw stuff for spectators
    if not SG_Minimap then return end -- Can't draw stuff without minimap info

    local pmo = p.mo

    local x, y = pmo.x, pmo.y
    local angle = pmo.angle

    local ofs = FixedDiv(((cv_small.value == 1) and 6 or 10)*FRACUNIT, SG_Minimap.zoom)
    x = x + FixedMul(ofs, cos(angle))
    y = y + FixedMul(ofs, sin(angle))

    v.drawOnMinimap(x, y, FRACUNIT, dot, v.getColormap(TC_DEFAULT, pmo.color), false)
end)
