local cv_spbicon = CV_RegisterVar {
    name = "spbicon",
    defaultvalue = "On",
    possiblevalue = CV_OnOff,
}

local spbs = {}

addHook("PreThinkFrame", function()
    if not cv_spbicon.value then return end
    spbs = {}
end)

addHook("MobjThinker", function(mo)
    if not cv_spbicon.value then return end
    if not mo.valid then return end -- -_-

    table.insert(spbs, mo)
end, MT_SPB)

local function shouldDraw(mo)
    if not mo.tracer then return true end

    local dist = FixedHypot(mo.x-mo.tracer.x, mo.y-mo.tracer.y)/mo.tracer.scale

    if dist < 3072 then
        return dist > 1024, (leveltime/2 % 2 == 0)
    end

    return true
end

hud.add(function(v)
    if not cv_spbicon.value then return end

    for i, mo in ipairs(spbs) do
		if v.interpolate then v.interpolate(i) end

        -- Could've been removed
        if mo.valid then
            local draw, red = shouldDraw(mo)

            if shouldDraw(mo) then
                local tc = red and TC_BLINK or TC_DEFAULT
                local color = SKINCOLOR_RED

                if not red and mo.color ~= 0 then
                    color = mo.color
                end

                v.drawOnMinimap(mo.x, mo.y, FRACUNIT, v.cachePatch("K_SPTKRM"), v.getColormap(tc, color), false)
            end
		end

		if v.interpolate then v.interpolate(false) end
    end
end)
