freeslot("S_COLORHEART", "SPR_RHRT", "S_LHRT", "MT_CDLHRT")

-- sounds
freeslot("sfx_cdamy1")
freeslot("sfx_cdamy2")

local hug = {}

local function addHugSkin(skin, sprite_name, appearance)
    local appearance = appearance or "default"
	local skin_upper = skin:upper()
	local hugstate_name = "S_PLAY_"..skin_upper.."_"..appearance:upper().."_HUG"

	freeslot(sprite_name, hugstate_name)

	states[_G[hugstate_name]] = {
		sprite = _G[sprite_name],
		frame = A,
		tics = -1
	}

    if not hug[skin] then hug[skin] = {} end

	hug[skin][appearance or "default"] = {
		hugstate = _G[hugstate_name],
	}
end

addHugSkin("amy", "SPR_HUAM")
addHugSkin("tails", "SPR_HUTA")
addHugSkin("arle", "SPR_HUAR")
addHugSkin("invidiay", "SPR_HUIN")
addHugSkin("invidiay", "SPR_HUI1", "invidiay_alt")
addHugSkin("invidiay", "SPR_HUI2", "invidiay_alt2")
addHugSkin("anime_girl", "SPR_HUMA")

states[S_COLORHEART] = {
	sprite = SPR_RHRT,
	tics = -1
}

-- Copied from srb2 src
states[S_LHRT] = {
	sprite = SPR_RHRT,
	frame = FF_FULLBRIGHT,
	tics = -1,
	action = nil,
	var1 = 0,
	var2 = 0,
	nextstate = S_NULL
}

-- Copied from srb2 src
 mobjinfo[MT_CDLHRT] = {
	doomednum	= -1,
	spawnstate	= S_LHRT,
	spawnhealth	= 1000,
	seestate	= S_NULL,
	seesound	= sfx_None,
	reactiontime	= 8,
	attacksound	= sfx_None,
	painstate	= S_NULL,
	painchance	= 0,
	painsound	= sfx_None,
	meleestate	= S_NULL,
	missilestate	= S_NULL,
	deathstate	= S_NULL,
	xdeathstate	= S_NULL,
	deathsound	= sfx_None,
	speed		= 4*FRACUNIT,
	radius		= 4*FRACUNIT,
	height		= 4*FRACUNIT,
	dipoffset	= 1,
	mass		= 4,
	damage		= 0,
	activesound	= sfx_None,
	flags		= MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_NOCLIP|MF_SCENERY,
	raisestate	= S_NULL
}

-- Alternative heart behavior
--addHook("MobjThinker", function(mo)
--	-- Make it flutter
--	local f = mo.fuse * (mo.target.radius<<6)
--	mo.momx = sin(f)
--	mo.momy = cos(f)
--end, MT_CDLHRT)

--local function SpawnHearts(player)
--	local mo = player.mo
--	local heart = P_SpawnMobj(mo.x, mo.y, mo.z + mo.height, MT_CDLHRT)
--	heart.color = mo.color
--	heart.scale = (6*mo.scale)>>3
--	heart.destscale = 0
--	heart.fuse = FixedMul(TICRATE<<1, P_RandomFixed()) + TICRATE>>1
--	heart.scalespeed = heart.scale / heart.fuse
--	heart.momz = FixedMul(mo.scale, P_RandomFixed()) + (mo.scale>>1)
--	heart.target = mo
--	heart.extravalue1 = mo.x
--	heart.extravalue2 = mo.y
--end

addHook("MobjThinker", function(mo)
	if mo.cvmem < 24 then mo.cvmem = $ + 1 end
	mo.movedir = $ + ANG10
	P_SetOrigin(
		mo,
		mo.extravalue1 + P_ReturnThrustX(mo, mo.movedir, mo.cvmem*mo.scale),
		mo.extravalue2 + P_ReturnThrustY(mo, mo.movedir, mo.cvmem*mo.scale),
		mo.z
	)
	if mo.fuse < 6 then
		mo.frame = ($ & ~FF_TRANSMASK) | ((10 - mo.fuse * 2) << FF_TRANSSHIFT)
	end
end, MT_CDLHRT)

local function SpawnHearts(player)
	local mo = player.mo
	local heart = P_SpawnMobj(mo.x, mo.y, mo.z + mo.height, MT_CDLHRT)
	heart.color = mo.color
	heart.scale = (5*mo.scale)>>4
	heart.destscale = heart.scale
	heart.fuse = (5*TICRATE)>>1
	heart.momz = mo.scale
	heart.target = mo
	heart.extravalue1 = mo.x
	heart.extravalue2 = mo.y
end

local function ReleaseHug(player)
	if player.hug then
		player.pflags = $ & ~PF_STASIS
		--player.mo.state = hug[player.mo.skin].standstate --S_PLAY_AMY_STND
		player.hugdelay = TICRATE

        if player.hug.valid then
            player.hug.pflags = $ & ~PF_STASIS
            player.hug.hugged = nil
        end

        player.hug = nil
	elseif player.hugged then
		player.pflags = $ & ~PF_STASIS
		player.hugdelay = TICRATE

        if player.hugged.valid then
            player.hugged.pflags = $ & ~PF_STASIS
            player.hugged.mo.angle = R_PointToDist2(player.mo.x, player.mo.y, player.hugged.mo.x, player.hugged.mo.y)
            player.hugged.drawangle = player.hugged.mo.angle
            player.hugged.hug = nil
        end

        player.hugged = nil
	end

	return false
end

local function UnhugEveryone()
	for player in players.iterate do
		if player.hug then
			ReleaseHug(player)
		end
	end
end

local amyhugs = CV_RegisterVar({"amyhugs", "On", CV_NETVAR|CV_CALL, CV_OnOff, UnhugEveryone})

addHook("ThinkFrame", function()
    if amyhugs.value == 0 then return end

	for player in players.iterate do
        if not (player.mo and player.mo.valid) then continue end

        -- Escape from hugs ;-;
        if (player.hugged and player.cmd.buttons & BT_CUSTOM3)
            or (player.hugged and not player.hugged.valid)
            or (player.hug and not player.hug.valid) then

            ReleaseHug(player)
            S_StartSound(player.mo, sfx_cdamy2)
        end

		if not hug[player.mo.skin] then continue end

        local appearance = "default"

        if APPEAR_GetAppearance then appearance = APPEAR_GetAppearance(player) end

        if not hug[player.mo.skin][appearance] then continue end

		local huggable
		local rosy = player

		-- Hug delay ticker
		if rosy.hugdelay then
			rosy.hugdelay = $ - 1
		end

		if rosy.hug and rosy.hug.valid then
			rosy.drawangle = rosy.hugangle
			rosy.pflags = $ | PF_STASIS
			rosy.hug.pflags = $ | PF_STASIS
			rosy.mo.state = hug[player.mo.skin][appearance].hugstate
			rosy.hugtime = $ + 1
		elseif abs(rosy.speed) < FRACUNIT then
            -- Don't do all those expensive checks if player is driving

			-- Let's find the closest person to hug!
			for p in players.iterate do
				-- Don't hug yourself
				if p == rosy then continue end

				-- It's another Rosy and she's not hugging you
				--if p.hug and rosy.hugged != p then continue end

				-- Hug only living players
				if not p.mo then continue end
				if p.playerstate != PST_LIVE then continue end

				-- Can't hug if not on the floor or doing anything
				if not(P_IsObjectOnGround(p.mo) and (p.panim == PA_IDLE or p.panim == PA_WALK or p.panim == PA_RUN)) then
					continue
				end

				-- Too high or too low to hug
				if abs(rosy.mo.z - p.mo.z) > FixedMul(4*FRACUNIT, mapobjectscale) then continue end

				-- target is driving
				if abs(p.speed) >= 1*FRACUNIT then continue end

				-- Too far away
				local dist = R_PointToDist2(rosy.mo.x, rosy.mo.y, p.mo.x, p.mo.y)
				if dist > 2*rosy.mo.radius + 2*p.mo.radius then continue end

				-- Update the candidates
				if not huggable then -- If huggable is unset, set it to p
					huggable = p
					huggable.dist = dist
				elseif dist < huggable.dist then -- huggable is set, check if better candidate
					huggable = p
					huggable.dist = dist
				end
			end
		end

		-- Did our closest player disappear? Get rid of the heart
		if not huggable and not (rosy.hug and rosy.hug.valid) and not rosy.thrown then
			if rosy.heart and rosy.heart.valid then
				P_RemoveMobj(rosy.heart)
			end

			rosy.heart = nil
			continue
		end

		-- Found someone? Place the heart indicator
		if not rosy.heart and huggable then
			rosy.heart = P_SpawnMobj(huggable.mo.x, huggable.mo.y, huggable.mo.z + huggable.mo.height + 24*huggable.mo.scale, 1)
			rosy.heart.state = S_COLORHEART
			rosy.heart.color = rosy.mo.color
			rosy.heart.scale = 2*huggable.mo.scale/3
			rosy.heart.fuse = -1
			rosy.heart.tracer = rosy.mo
			rosy.heart.target = huggable.mo
		end

		-- Hug/release
		if rosy.cmd.buttons & BT_CUSTOM1 and not rosy.hugdelay then
			if rosy.hug then
				ReleaseHug(rosy)
			else
				huggable.hugged = rosy
				rosy.hug = huggable
				rosy.hugtime = 0
				rosy.hugangle = R_PointToAngle2(rosy.mo.x, rosy.mo.y, huggable.mo.x, huggable.mo.y)
				local radius = huggable.mo.radius
				--P_TeleportMove(rosy.mo, huggable.mo.x + FixedMul(radius, cos(rosy.hugangle)), huggable.mo.y + FixedMul(radius, sin(rosy.hugangle)), rosy.mo.z)
				S_StartSound(rosy.mo, sfx_cdamy1)
				rosy.hugdelay = TICRATE
			end
		elseif rosy.hug and rosy.cmd.buttons & BT_CUSTOM2 then
			if (leveltime & 7) == 0 then
				SpawnHearts(rosy)
			end
		end
	end
end)

addHook("MobjThinker", function(mo)
	if mo.tracer then
		if not hug[mo.tracer.skin] or mo.tracer.player.hug or amyhugs.value == 0 then
			mo.tracer.heart = nil
			P_RemoveMobj(mo)
		else
			mo.color = mo.tracer.color
            if mo.target then
                mo.scale = 2*mo.target.scale/3
                local z = mo.target.z + mo.target.height + FixedMul((16 + abs((leveltime % TICRATE) - TICRATE/2))*FRACUNIT, mo.target.scale)
                P_SetOrigin(mo, mo.target.x, mo.target.y, z)
            end
			return true
		end
	elseif not mo.tracer and mo.state == S_COLORHEART then
		P_RemoveMobj(mo)
	end
end, 1)

addHook("PlayerSpawn", function(p)
	p.hug = nil
	p.hugged = nil
end)

addHook("JumpSpecial", ReleaseHug)
