-- Created by Indev for Sunflower's Garden

-- Relies on hostmod's sound
--freeslot("sfx_sysmsg")

local tips = {}
local shown_tips = {}

local cv_sgdc = CV_RegisterVar({
    name = "tips_sgdc",
    defaultvalue = "Off",
    possiblevalue = CV_OnOff,
    flags = CV_NETVAR,
})

-- I have to paste same function over and over, maybe i need to make some kind
-- of "lua utilities" module? :P
local function colorstr(str)
    local buff = {}

    local pos = 0
    local len = #str

    while pos <= len do
        local char = string.sub(str, pos, pos)

        if char == '\\' then
            local charnum = tonumber(string.sub(str, pos+1, pos+3))

            if charnum == nil then
                print("\130WARNING\128: colorstr(): could not decode character near char #"..(pos+1)..", string: "..str)
            else
                char = string.char(charnum)

                pos = pos + 3
            end
        end

        pos = pos + 1

        table.insert(buff, char)
    end

	return table.concat(buff, "")
end

rawset(_G, "TIP_AddMapTip", function(map, tiptext, only_show_once, globalid)
    local map = map:upper()

    local map_tips = tips[map] or {}

    tiptext = colorstr(tiptext)

    if only_show_once and not globalid then
        local tipnum = #map_tips + 1

        globalid = "__"..map.."_only_show_once_tip"..tipnum
    end

    table.insert(map_tips, {
        text = tiptext,
        only_show_once = only_show_once,
        globalid = globalid,
    })

    tips[map] = map_tips
end)

rawset(_G, "TIP_AddMapTipSGDC", function(map, tiptext, only_show_once, globalid)
    local map = map:upper()

    local map_tips = tips[map] or {}

    tiptext = colorstr(tiptext)

    if only_show_once and not globalid then
        local tipnum = #map_tips + 1

        globalid = "__"..map.."_only_show_once_tip"..tipnum
    end

    table.insert(map_tips, {
        text = tiptext,
        only_show_once = only_show_once,
        globalid = globalid,
        sgdc = true,
    })

    tips[map] = map_tips
end)

local tipmap, tiplist
addHook("MapLoad", function(mapid)
    local map = G_BuildMapName(mapid)

    if tipmap ~= map then
        tipmap = map
        tiplist = tips[map]
    else
        tiplist = nil
    end
end)

addHook("ThinkFrame", function()
    if leveltime > 1 and tiplist ~= nil then
        if leveltime % TICRATE == 0 then
            local tipnum = leveltime/TICRATE
            local tip = tiplist[tipnum]

            if tip then
                if tip.sgdc and not cv_sgdc.value then
                    return
                end

                if tip.only_show_once then
                    if shown_tips[tip.globalid] then
                        return
                    else
                        shown_tips[tip.globalid] = true
                    end
                end

                chatprint(tip.text)
                S_StartSound(nil, sfx_sysmsg)
            else
                -- No more tips
                tiplist = nil
            end
        end
    end
end)
