--MRP
--MiniRank Plus
--by Callmore

local FACE_X = 9
local FACE_Y = 92

local hudeditenable = true

local facegfx = {}
local highresfacegfx = {}
local appearancecache = {}
local pingnumgfx = nil
local clrpingnumgfx = nil
local hilightgfx = nil
local nobumpersgfx = nil
local bumpergfx = nil
local miniitemgfx = nil
local miniiteminvulgfx = nil
local sadgfx = nil
local hornmodgfx = nil
local frboardergfx = nil
local staticbrd = nil

local loadedconfig = false

--CONSTANTS
local DT_NORMAL = 0
local DT_COMBI = 1

local FACEWIDTH = 16

local ITEMMINI = {
	"K_ISSHOE",
	"K_ISRSHE",
	"K_ISINV1",
	"K_ISBANA",
	"K_ISEGGM",
	"K_ISORBN",
	"K_ISJAWZ",
	"K_ISMINE",
	"K_ISBHOG",
	"K_ISSPB",
	"K_ISGROW",
	"K_ISSHRK",
	"K_ISTHNS",
	"K_ISHYUD",
	"K_ISPOGO",
	"K_ISSINK"
}

local spinoutstart = {}

--local cgb_namecolor = CONFIG_RegisterVar{
--    name = "cgb_skinname_color",
--    defaultvalue = "PrefColor",
--    possiblevalue = {
--        PrefColor = 0,
--        PlayerColor = 1,
--    },
--    config_menu = "HUD",
--    displayname = "Skin Name Color",
--    description = "Colorize skin name in CGB HUD."
--}

local cv_showitems = CV_RegisterVar{
	name = "mrp_showitems",
	defaultvalue = "Hyudoro",
	flags = CV_NETVAR,
	PossibleValue = {No = 0, Yes = 1, Hyudoro = 2},
}
local cv_showitemslocal = CONFIG_RegisterVar{
	name = "mrp_showitemslocal",
	defaultvalue = "Yes",
	flags = 0,
	PossibleValue = CV_YesNo,
	config_menu = "Mini Rankings Plus",
	displayname = "Show Items",
	description = "Show Items in Mink rankings. This feature must be enabled by host.",
}
local cv_showitemswhenspectating = CONFIG_RegisterVar {
	name = "mrp_showitemswhenspectating",
	defaultvalue = "No",
	flags = 0,
	PossibleValue = CV_YesNo,
	config_menu = "Mini Rankings Plus",
	displayname = "Show Items when spectating",
	description = "Show Items in Mink rankings when spectating someone.",
}
local cv_hpmodshowhp = CV_RegisterVar{
	name = "mrp_hpmodshowhp",
	defaultvalue = "Yes",
	flags = CV_NETVAR,
	PossibleValue = CV_YesNo,
}
local cv_hpmodshowhplocal = CONFIG_RegisterVar {
	name = "mrp_hpmodshowhplocal",
	defaultvalue = "Yes",
	flags = 0,
	PossibleValue = CV_YesNo,
	config_menu = "Mini Rankings Plus",
	displayname = "Show HP",
	description = "Show HP in Mini rankings when hpmod is active. This feature must be enabled by host.",
}
local cv_showhorns = CONFIG_RegisterVar {
	name = "mrp_showhorns",
	defaultvalue = "Yes",
	flags = 0,
	PossibleValue = CV_YesNo,
	config_menu = "Mini Rankings Plus",
	displayname = "Show Horns",
	description = "Show Horns in Mini rankings when someone using one.",
}
local cv_shrinkgrow = CONFIG_RegisterVar {
	name = "mrp_shrinkgrow",
	defaultvalue = "Yes",
	flags = 0,
	PossibleValue = CV_YesNo,
	config_menu = "Mini Rankings Plus",
	displayname = "Show Grow/Shrink",
	description = "Show Grow/Shrink in Mini rankings when effect is active.",
}
local cv_spinoutshake = CONFIG_RegisterVar {
	name = "mrp_spinoutshake",
	defaultvalue = "Yes",
	flags = 0,
	PossibleValue = CV_YesNo,
	config_menu = "Mini Rankings Plus",
	displayname = "Shake icon on spin out",
	description = "Shake Mini rankings icon when player spins out.",
}
local cv_showflashtics = CONFIG_RegisterVar {
	name = "mrp_showflashtics",
	defaultvalue = "Yes",
	flags = 0,
	PossibleValue = CV_YesNo,
	config_menu = "Mini Rankings Plus",
	displayname = "Show Flashtics",
	description = "Show Flashtics in Mini rankings when effect is active.",
}
local cv_showinvis = CONFIG_RegisterVar {
	name = "mrp_showinvis",
	defaultvalue = "Yes",
	flags = 0,
	PossibleValue = CV_YesNo,
	config_menu = "Mini Rankings Plus",
	displayname = "Show invisibility",
	description = "Show invisibility in Mini rankings when effect is active.",
}
local cv_showcombi = CONFIG_RegisterVar {
	name = "mrp_showcombi",
	defaultvalue = "Yes",
	flags = 0,
	PossibleValue = CV_YesNo,
	config_menu = "Mini Rankings Plus",
	displayname = "Show combi",
	description = "Show combi in Mini rankings when it is active.",
}
local cv_showfriendmodteams = CONFIG_RegisterVar {
	name = "mrp_friendmodshowteams",
	defaultvalue = "Yes",
	flags = 0,
	PossibleValue = CV_YesNo,
	config_menu = "Mini Rankings Plus",
	displayname = "Show friendmod teams",
	description = "Show friendmod teams in Mini rankings when friendmod is active.",
}
local cv_showdnf = CONFIG_RegisterVar {
	name = "mrp_showdnf",
	defaultvalue = "Yes",
	flags = 0,
	PossibleValue = CV_YesNo,
	config_menu = "Mini Rankings Plus",
	displayname = "Show DNF icon",
	description = "Show 'Did Not Finish' icon Mini rankings.",
}
local cv_powerblink = CONFIG_RegisterVar {
	name = "mrp_powerblink",
	defaultvalue = "Yes",
	flags = 0,
	PossibleValue = CV_YesNo,
	config_menu = "Mini Rankings Plus",
	displayname = "Power Item Blink",
	description = "Player icon will blink 3 seconds before their power item runs out.",
}

local forcedisplay_t = {
	name = "mrp_forcedisplay",
	defaultvalue = "None",
	flags = CV_CALL,
	PossibleValue = {On = 1, None = 0, Off = -1, Vanilla = -2},
	func = function (self)
		if self.value == -2 then
			hud.enable("minirankings")
		end
	end,
}

local cv_forcedisplay = CONFIG_RegisterVar(forcedisplay_t)

forcedisplay_t.config_menu = "Mini Rankings Plus"
forcedisplay_t.displayname = "Force Mini rankings"
forcedisplay_t.description = "Force display Mini rankings (On - always display, None - default behavior, Off - hide minirankings, Vanilla - use vanilla minirankings)."

local showstats = {Never = 0, Restat = 1, Always = 2}
local cv_showstats = CONFIG_RegisterVar {
    name = "mrp_showstats",
    defaultvalue = "Restat",
    PossibleValue = showstats,
	config_menu = "Mini Rankings Plus",
	displayname = "Show stats",
	description = "Show stats in Mini rankings (Always - always display, Restat - only when under restat effect, Never - hide).",
}

local cv_face_xoff, cv_face_yoff

local mrp_xoff_t = {
    name = "hud_mrp_xoffset",
    defaultvalue = 0,
    PossibleValue = {MIN = -1000, MAX=1000}, -- Just need to an excuse to add PossibleValue because i have ptsd of CV_CALL segfaulting game
    flags = CV_CALL|CV_NOINIT,
    func = function(cv)
        if cv_face_xoff then
            CV_Set(cv_face_xoff, cv.value)
        end
    end,
}

local cv_mrp_xoff = CONFIG_RegisterVar(mrp_xoff_t)

mrp_xoff_t.config_menu = "Mini Rankings Plus"
mrp_xoff_t.displayname = "HUD offset"
mrp_xoff_t.description = "Change the offsets for Mini rankings."
mrp_xoff_t.config_hudmove = "hud_mrp_yoffset"

local cv_mrp_yoff = CV_RegisterVar {
    name = "hud_mrp_yoffset",
    defaultvalue = 0,
    PossibleValue = {MIN = -1000, MAX=1000}, -- Just need to an excuse to add PossibleValue because i have ptsd of CV_CALL segfaulting game
    flags = CV_CALL|CV_NOINIT,
    func = function(cv)
        if cv_face_yoff then
            CV_Set(cv_face_yoff, cv.value)
        end
    end,
}

local function linkOffsets()
    if cv_face_xoff then
        CV_StealthSet(cv_mrp_xoff, cv_face_xoff.value)
        CV_StealthSet(cv_mrp_yoff, cv_face_yoff.value)
    end
end

local function lookupOffsets()
    if cv_face_xoff then return end
    cv_face_xoff = CV_FindVar("hud_face_xoffset")
    cv_face_yoff = CV_FindVar("hud_face_yoffset")

    linkOffsets()
end

local cv_highresportrait

local cv_mrp_highresportrait = CONFIG_RegisterVar {
	name = "hud_mrp_highresportrait",
	defaultvalue = "Off",
	PossibleValue = CV_OnOff,
	config_menu = "Mini Rankings Plus",
	displayname = "High Resolution Portrait",
	description = "Use high resolution portrait in Mini rankings. Inverted if highresportrait is enabled.",
}

local function useHighresPortrait()
	if cv_highresportrait and cv_highresportrait.value == 1 then
		return cv_highresportrait.value ~= cv_mrp_highresportrait.value
	end

	return cv_mrp_highresportrait.value == 1
end

local function lookupPortrait()
	if cv_highresportrait then return end
	cv_highresportrait = CV_FindVar("highresportrait")
end

addHook("MapLoad", lookupOffsets)
addHook("NetVars", lookupOffsets)

addHook("MapLoad", lookupPortrait)
addHook("NetVars", lookupPortrait)

--ffs why doesent lua have a random function
--i have to create a random function just for hornmod to not look suck

--yes this was also copied from source
local rseed = 0xBADE4404
local function hudRandom()
	rseed = $ ^^ ($ >> 13)
	rseed = $ ^^ ($ >> 13)
	rseed = $ ^^ ($ << 21)
	return ( (rseed*36548569) >> 4) & (FRACUNIT-1)
end

local function hudRandomRange(a, b)
	return ((hudRandom() * (b-a+1)) >> FRACBITS) + a
end

--latius wanted this so ayyy
rawset(_G, "minrankplus", {
    enabled = true
})

local function sortfunc(a, b)
	return a[1].kartstuff[k_position] < b[1].kartstuff[k_position]
end

local function calcXOffsetSpinout(p, dt)

	--return 0 if shake off
	if not cv_spinoutshake.value then return 0 end

	if not (p and p.valid) then return 0 end -- this is stupid i hate this pls
	if dt == DT_COMBI and not (p.combi_p and p.combi_p.valid) then return 0 end -- this is stupid i hate this pls

	--dont do any shake
	if not (spinoutstart[#p] or (dt == DT_COMBI and spinoutstart[#p.combi_p])) then return 0 end

	local spint = p.kartstuff[k_spinouttimer]
	if p.pflags&PF_TIMEOVER then
		spint = 0
	end
	local spintc = 0
	if dt == DT_COMBI then
		if p.combi_p.pflags&PF_TIMEOVER then
			spintc = 0
		else
			spintc = p.combi_p.kartstuff[k_spinouttimer]
		end
	end

	--figgure out some player specific vars for combi
	local t = leveltime-(spinoutstart[#p] or leveltime)
	local spinoutt = spint
	if dt == DT_COMBI then
		t = leveltime - max(spinoutstart[#p] or spinoutstart[#p.combi_p], spinoutstart[#p.combi_p] or spinoutstart[#p])
		spinoutt = max(spint or spintc, spintc or spint)
	end
	local spinoutang = FixedAngle(FixedDiv((t%(TICRATE/2)), TICRATE)*720)
	--print(spinoutang/ANG1)
	local spinoutshake = (sin(spinoutang)*spinoutt)/5
	--print(spinoutshake)
	return spinoutshake
end

local playersingame = {}
local alreadycombi = {}
local onsameteam = {}
local displaypos = 0
local rankcenter = 3
local xanioff = FACE_X

local function hudThink()
	playersingame = {}
	alreadycombi = {}
	onsameteam = {}

    linkOffsets()

	if (not loadedconfig) and consoleplayer then
		COM_BufInsertText(consoleplayer, "exec mrp.cfg -silent")
		loadedconfig = true
	end

	local dp = displayplayers[0]

	for p in players.iterate do
		if not spinoutstart[#p] and p.kartstuff[k_spinouttimer] then
			spinoutstart[#p] = leveltime
		elseif spinoutstart[#p] and not p.kartstuff[k_spinouttimer] then
			spinoutstart[#p] = nil
		end

		if not (p.valid and not p.spectator) then continue end

		-- Combi support
		if not alreadycombi[p] then --skip someone if their parner was already read
			local dt = DT_NORMAL
			if cv_showcombi.value
			and p.combi_p
			and p.combi_p.valid
			and not p.combi_p.spectator then
				--HA
				--YOU WONT TROLL ME WITH ADDING AN MO INSTEAD OF A PLAYER
				dt = DT_COMBI
				alreadycombi[p.combi_p] = true
			end
			playersingame[#playersingame+1] = {p, dt}
			--so... all player names have to be unike...
		end

		-- FRIENDMOD support
		if FRIENDMOD_Active and p.frn and dp.frn and dp ~= p and dp.frn.team == p.frn.team then
			onsameteam[p] = true
		end
	end

	if (#playersingame <= 1) and (cv_forcedisplay.value ~= 1) then return end

	if server.vir_enabled then return end -- WORLDS EASIEST MOD INTERGRAION

	table.sort(playersingame, sortfunc)

	displaypos = 0
	for i, k in ipairs(playersingame) do
		if k[1] == dp then
			displaypos = i
			break
		end
	end

	rankcenter = 3
	if #playersingame > 5 and G_RaceGametype() then
		rankcenter = min(max(3, displaypos), #playersingame-2)
	end

	if leveltime < TICRATE*20 then
		xanioff = min(leveltime*5-(TICRATE*45), FACE_X)
	end
end

addHook("ThinkFrame", hudThink)

-- FIXME: these wouldn't be necessary if i just fixed mixed patch/string drawing while latched
-- yes it's fixable. i am just stupid sometimes
local function patchinterp(v, x)
	if v.interpolate then
		v.interpLatch(true)
		v.draw(x, 0, v.cachePatch("K_TRNULL"))
	end
end
local function stringinterp(v, x)
	if v.interpolate then
		v.interpLatch(true)
		v.drawString(x, 0, "")
	end
end

-- There can't be more than 999 players right? right??? :AAAAAAAA:
local function drawRankNum(v, x, y, num, flags, colormap)
    -- Special colored nums for people in first 3 places
    if clrpingnumgfx[num] then
        v.draw(x, y, clrpingnumgfx[num], flags, colormap)
        return
    end

    local num1 = num / 100
    local num2 = (num % 100) / 10
    local num3 = (num % 10)

    if num1 ~= 0 then
        v.draw(x, y, pingnumgfx[num1], flags, colormap)
        x = x + pingnumgfx[num1].width-1
    end

    if num2 ~= 0 then
        v.draw(x, y, pingnumgfx[num2], flags, colormap)
        x = x + pingnumgfx[num2].width-1
    end

    v.draw(x, y, pingnumgfx[num3], flags, colormap)
end

local function drawMinirank(v, p)

	if p ~= displayplayers[0] then return end

	--####################
	--###CACHE GRAPHICS###
	--####################

	do
		for s in skins.iterate do
			if facegfx[s.name] then continue end
			--print("Caching " .. s.facerank .. " into " .. #s)
			facegfx[s.name] = v.cachePatch(s.facerank)
			highresfacegfx[s.name] = v.cachePatch(s.facewant)
        end

        if not pingnumgfx then
            pingnumgfx = {}
            for i = 0, 9 do
                pingnumgfx[i] = v.cachePatch(string.format("PINGN%d", i))
            end
        end

        if not clrpingnumgfx then
            clrpingnumgfx = {}
            for i = 1, 3 do
                clrpingnumgfx[i] = v.cachePatch(string.format("CLRRNK0%d", i))
            end
        end

		if not hilightgfx then
			hilightgfx = {}
			for i = 1, 8 do
				--print("Caching K_CHILI" .. i .. " into " .. i)
				hilightgfx[i-1] = v.cachePatch("K_CHILI" .. i)
			end
		end

		if not nobumpersgfx then
			nobumpersgfx = v.cachePatch("K_NOBLNS")
		end

		if not bumpergfx then
			bumpergfx = {}
			bumpergfx[1] = v.cachePatch("K_BLNA")
			bumpergfx[2] = v.cachePatch("K_BLNB")
		end

		if not miniitemgfx then
			miniitemgfx = {}
			for i, k in ipairs(ITEMMINI) do
				--print("Caching " .. k .. " into " .. i)
				miniitemgfx[i] = v.cachePatch(k)
			end
		end

		if not miniiteminvulgfx then
			miniiteminvulgfx = {}
			for i = 1, 6 do
				--print("Caching K_ISINV" .. i .. " into " .. i)
				miniiteminvulgfx[i] = v.cachePatch("K_ISINV" .. i)
			end
		end

		if not sadgfx then
			sadgfx = v.cachePatch("K_ITSAD")
		end

		if HORNMOD and not hornmodgfx then
			hornmodgfx = v.cachePatch("HORNA0")
		end

		if not frboardergfx then
			frboardergfx = {}
			for i = 1, 8 do
				--print("Caching K_ISINV" .. i .. " into " .. i)
				frboardergfx[i-1] = v.cachePatch("FRBOARD" .. i)
			end
		end

        if not staticbrd then
            staticbrd = v.cachePatch("STATICBRD")
        end
	end


	if not (minrankplus and minrankplus.enabled) then return end

	if cv_forcedisplay.value ~= -2 and hud.enabled("minirankings") then
		hud.disable("minirankings")
	end

	if outrun and outrun.running then return end

	--#########################
	--###GENERATE PLACEMENTS###
	--#########################

	--if leveltime < TICRATE*10 then return end
	if (splitscreen) and (cv_forcedisplay.value ~= 1) then return end

	--stupid mod compat stuff

	if (#playersingame <= 1) and (cv_forcedisplay.value ~= 1) then return end

	if cv_forcedisplay.value < 0 then return end

	if SG_MapReset() or SG_BattleFullscreen(p) then return end

	if server.vir_enabled then return end -- WORLDS EASIEST MOD INTERGRAION

	--####################
	--###DRAW MINI RANK###
	--####################


	for i = -2, 2 do
		if playersingame[rankcenter+i] then

			--draw the players icon, and other extra stuff because AYYYY
			local rankplayer = playersingame[rankcenter+i][1]

			if not (rankplayer and rankplayer.valid and rankplayer.mo and rankplayer.mo.valid) then continue end

			local drawtype = playersingame[rankcenter+i][2]
			local colorized = {rankplayer.mo.skin}
			local skincolor = {rankplayer.mo.color}
			local vflags = V_HUDTRANS|V_SNAPTOLEFT
			local xpos = xanioff+FixedInt(calcXOffsetSpinout(rankplayer, drawtype)) + cv_mrp_xoff.value
			local ypos = (FACE_Y+(i*18)+(max(0, 5-#playersingame)*9)) + cv_mrp_yoff.value

			if v.interpolate then v.interpolate(#rankplayer) end
			patchinterp(v, xpos)

			if rankplayer.mo.colorized then
				colorized[1] = TC_RAINBOW
			end

			--calulate combi
			local colormap = {v.getColormap(colorized[1], skincolor[1])}
			local plrs = {rankplayer}
			if drawtype == DT_COMBI
			and rankplayer and rankplayer.valid
			and rankplayer.combi_p and rankplayer.combi_p.valid
			and rankplayer.combi_p.mo and rankplayer.combi_p.mo.valid then
				plrs[2] = rankplayer.combi_p
				skincolor[2] = plrs[2].mo.color
				colorized[2] = plrs[2].mo.skin
				if plrs[2].mo.colorized then
					colorized[2] = TC_RAINBOW
				end

				colormap[2] = v.getColormap(colorized[2], skincolor[2])
			else
				drawtype = DT_NORMAL
			end

			--draw items OR rocket sneakers OR eggbox timer

			--ITEM DRAW MATHS!!!
			if (cv_showitems.value and cv_showitemslocal.value)
			or (cv_showitemswhenspectating.value and consoleplayer.spectator) then -- should show if the player who
				for i, k in ipairs(plrs) do
					if not (k and k.valid and not k.spectator) then continue end
					if k.pflags&PF_TIMEOVER then continue end

					local itemxoff = (i-1)*(20*FRACUNIT)
					if drawtype == DT_COMBI then
						itemxoff = $+15*FRACUNIT
					end
					local itemyoff = 0
					local itemscale = FRACUNIT/2+FRACUNIT/4
					do
						local faceheight = 16*FRACUNIT
						local mitemheight = -(47*FRACUNIT)/2
						itemyoff = FixedMul(mitemheight, itemscale)+(faceheight/2)
					end

					if k.kartstuff[k_eggmanexplode] then
						local cmap = nil
                        local flashtime = 4<<(k.kartstuff[k_eggmanexplode]/TICRATE)
						if k.mo.colorized then
							cmap = v.getColormap(TC_BLINK, k.mo.color)
						end
						v.drawScaled((xpos*FRACUNIT)+(8*FRACUNIT)+itemxoff, ypos*FRACUNIT+itemyoff, itemscale, miniitemgfx[5], vflags, cmap)
					end

                    if (cv_showitems.value == 2 and p.kartstuff[k_itemtype] != 14) then continue end

					local drawstr = false
					if not k.kartstuff then continue end
					local itemcount = k.kartstuff[k_itemamount]

					--alright so im gonna move this into a function since it getting beeg
					--nevermind time for it to be the beegest if statement
					--hmm maybe i can make this a masive for loop LOL
					if k.kartstuff[k_rocketsneakertimer] and p.kartstuff[k_itemtype] != 14 then
						if not (leveltime&1) then
							v.drawScaled((xpos*FRACUNIT)+(8*FRACUNIT)+itemxoff, ypos*FRACUNIT+itemyoff, itemscale, miniitemgfx[2], vflags)
						end
					elseif k.kartstuff[k_itemtype] and
                           not k.kartstuff[k_itemblink] and
                           (not k.kartstuff[k_hyudorotimer] or consoleplayer.spectator) and
                           not k.kartstuff[k_itemheld] then
						local itemp = miniitemgfx[k.kartstuff[k_itemtype]] or sadgfx
						drawstr = true
						--inv is shiny
						if k.kartstuff[k_itemtype] == KITEM_INVINCIBILITY then
							itemp = miniiteminvulgfx[((leveltime%(6*3))/3)+1]
						end
						--draw item stack (or amount as a number if more than 5)
						if not (k.kartstuff[k_itemheld] and not (leveltime&1)) then
							if itemcount > (drawtype == DT_COMBI and 1 or 5) then
								v.drawScaled((xpos*FRACUNIT)+(8*FRACUNIT)+itemxoff, ypos*FRACUNIT+itemyoff, itemscale, itemp, vflags)
							else
								for i = itemcount-1, 0, -1 do
									v.drawScaled((xpos*FRACUNIT)+((8+(i*2))*FRACUNIT)+itemxoff, ypos*FRACUNIT+itemyoff, itemscale, itemp, vflags)
								end
							end
						end
					end

					--draw item count
					if drawstr and itemcount>(drawtype == DT_COMBI and 1 or 5) then
						stringinterp(v, xpos)
						v.drawString(xpos+26+FixedInt(itemxoff), ypos+6, itemcount, vflags)
						patchinterp(v, xpos)
					end
				end -- END FOR
			end

			--drawScaled

			--face
			--also some code to make it fade if hyudo or flashtics
			local facescale = 0 -- need this for hornmod lol
			for i, k in ipairs(plrs) do
				local facexoff = (i-1)*(15*FRACUNIT)
				local facevflags = vflags
				if (k.kartstuff[k_hyudorotimer] and cv_showinvis.value)
				or
				( -- This condition looks kinda ugly, probably need to reformat it somehow
					cv_powerblink.value and not ((leveltime/3)&1) and
					(
						(k.kartstuff[k_invincibilitytimer] and k.kartstuff[k_invincibilitytimer] < 3*TICRATE)
						or (k.kartstuff[k_growshrinktimer] and abs(k.kartstuff[k_growshrinktimer]) < 3*TICRATE)
					)
				)
				or ((k.powers[pw_flashing] and not (leveltime&1)
				and not k.kartstuff[k_wipeoutslow]
				and not k.kartstuff[k_spinouttimer]
				and not k.kartstuff[k_respawn]) and cv_showflashtics.value) then
					facevflags = $&(~V_HUDTRANS)
					facevflags = $|V_HUDTRANSHALF
				end
				--grow scaling
				local faceoffs = 0
				if not (k.pflags&PF_TIMEOVER) and cv_shrinkgrow.value then --yeah not if you timeover lol
					if k.kartstuff[k_growshrinktimer]>0 or (HugeQuest and k.huge>0) then
						faceoffs = -(FACEWIDTH*FRACUNIT/8)
						facescale = FRACUNIT/4
					elseif k.kartstuff[k_growshrinktimer]<0 or k.kartstuff[k_squishedtimer]>0 then
						faceoffs = (FACEWIDTH*FRACUNIT/8)
						facescale = -FRACUNIT/4
					end
				end

				local facepatch = useHighresPortrait() and highresfacegfx[k.mo.skin] or facegfx[k.mo.skin]

                -- TODO - better check maybe?
                if APPEAR_GetAppearance and APPEAR_GetAppearance(k) ~= "default" then
                    -- TODO - better cache
                    local facepatchname = useHighresPortrait() and APPEAR_GetWantedGFX(k) or APPEAR_GetRankGFX(k)

                    if not appearancecache[facepatchname] then
                        appearancecache[facepatchname] = v.cachePatch(facepatchname)
                    end

                    facepatch = appearancecache[facepatchname]
                end

				local scale = (FRACUNIT+facescale) / (useHighresPortrait() and 2 or 1)

				v.drawScaled((xpos*FRACUNIT)+faceoffs+facexoff, ypos*FRACUNIT+faceoffs, scale, facepatch, facevflags, colormap[i])

				if k == p and k.kartstuff[k_position] > 3 then
					v.drawScaled((xpos*FRACUNIT)+faceoffs+facexoff, ypos*FRACUNIT+faceoffs, FRACUNIT+facescale, hilightgfx[(leveltime / 4) % 8], vflags)
				end

                if k.kartstuff[k_position] < 4 then
                    local color = SKINCOLOR_MUSTARD

                    if k.kartstuff[k_position] == 2 then
                        color = SKINCOLOR_SILVER
                    end

                    if k.kartstuff[k_position] == 3 then
                        color = SKINCOLOR_CINNAMON
                    end

                    local patch = staticbrd

                    if k == p then patch = frboardergfx[(leveltime / 4) % 8] end

					v.drawScaled((xpos*FRACUNIT)+faceoffs+facexoff, ypos*FRACUNIT+faceoffs, FRACUNIT+facescale, patch, vflags, v.getColormap(0, color))
				end

				if onsameteam[k] and cv_showfriendmodteams.value then
					v.drawScaled((xpos*FRACUNIT)+faceoffs+facexoff, ypos*FRACUNIT+faceoffs, FRACUNIT+facescale, frboardergfx[(leveltime / 4) % 8], vflags, v.getColormap(0, FRIENDMOD_Teamcolor(p.frn.team)))
				end
			end

			--draw bumpers
			if hud.enabled("battlerankingsbumpers") --[[and not G_NoBumperBattleGametype()]] then
				for i, k in ipairs(plrs) do
					local itemxoff = (i-1)*(20*FRACUNIT)
					if drawtype == DT_COMBI then
						itemxoff = $+15*FRACUNIT
					end

					if G_BattleGametype() and k.kartstuff[k_bumper] > 0 then
						v.draw(xpos+17+itemxoff, ypos, bumpergfx[1], vflags, colormap[i])
						for b = 1, k.kartstuff[k_bumper]-1 do
							v.draw(xpos+(19+(b*5))+itemxoff, ypos, bumpergfx[2], vflags, colormap[i])
						end
					end
				end
			end

			--hpmod compat (ez, also my mod lol)
			if hpmod and hpmod.running
			and (cv_hpmodshowhp.value and cv_hpmodshowhplocal.value) then
				for i, k in ipairs(plrs) do
                    local hpcolor = V_GREENMAP

                    if k.hpmod.hp < hpmod.maxhp/3 then
                        hpcolor = V_REDMAP
                    elseif k.hpmod.hp < 2*hpmod.maxhp/3 then
                        hpcolor = V_ORANGEMAP
                    end

					local facexoff = (i-1)*(15)

					if k.hpmod then
						stringinterp(v, xpos)
						v.drawString(xpos+facexoff+15, ypos+1, k.hpmod.hp, vflags|hpcolor, "small-right")
						patchinterp(v, xpos)
					end
				end
			end

			--no bumper indicator
			for i, k in ipairs(plrs) do
				local facexoff = (i-1)*15
				if ((G_BattleGametype() and k.kartstuff[k_bumper] <= 0) and not (hpmod and hpmod.running))
				or (k.pflags&PF_TIMEOVER and cv_showdnf.value) then
					v.draw(xpos-4+facexoff, ypos-3, nobumpersgfx, vflags)
				end
			end

			--placement (eh whatever show both anyway!)
            local colormap = nil

            if rankplayer.kartstuff[k_position] == 1 then
                colormap = v.getColormap(0, SKINCOLOR_MUSTARD)
            elseif rankplayer.kartstuff[k_position] == 2 then
                colormap = v.getColormap(0, SKINCOLOR_SILVER)
            elseif rankplayer.kartstuff[k_position] == 3 then
                colormap = v.getColormap(0, SKINCOLOR_CINNAMON)
            end

            drawRankNum(v, xpos-5, ypos+10, rankplayer.kartstuff[k_position], vflags, colormap)

            -- Draw stats
            if cv_showstats.value ~= showstats.Never then
                for i, k in ipairs(plrs) do
                    local facexoff = (i-1)*15
                    local color = 0

                    if cv_showstats.value == showstats.Always and k.HMRs then
                        color = V_YELLOWMAP
                    end

                    if cv_showstats.value == showstats.Always or k.HMRs then
                        stringinterp(v, xpos)
                        v.drawString(xpos+facexoff+1, ypos+1, k.kartspeed, vflags|color, "small")
                        v.drawString(xpos+facexoff+15, ypos+11, k.kartweight, vflags|color, "small-right")
                        patchinterp(v, xpos)
                    end
                end
            end

			--hornmod is funni
			if HORNMOD and cv_showhorns.value then
				for i, k in ipairs(plrs) do
					if k.hornmod and k.hornmod.visual then
						local visual = k.hornmod.visual
						local facexoff = (i-1)*15

						-- G: Who needs shake when you can do THIS!?
						local shakex = (k.mo.x - visual.x)/4
						local shakey = (k.mo.y - visual.y)/4
						local destx = (facexoff+10)*FRACUNIT + (abs(shakex) > FRACUNIT>>2 and shakex or 0) -- hlep how clamp
						local desty = 6*FRACUNIT + (abs(shakey) > FRACUNIT>>2 and shakey or 0)

						local scale = FRACUNIT + facescale
						if k.hornmod.flash then scale = FixedMul($, 11*FRACUNIT/10) end

						-- shutup
						if visual.flags2 & MF2_SHADOW then vflags = ($ & ~V_ALPHAMASK) | V_HUDTRANSHALF end

						-- encore
						if encoremode then
							vflags = $ | V_FLIP
							destx = $ - 4*FRACUNIT
						end

						if v.interpolate then
							v.interpLatch(true)
							v.drawScaled(destx + xpos*FRACUNIT, desty, 0, v.cachePatch("K_TRNULL"))
						end
						v.drawScaled(destx + xpos*FRACUNIT, desty + ypos*FRACUNIT, scale/4, hornmodgfx, vflags, v.getColormap(TC_RAINBOW, visual.color))
					end
				end
			end
		end
	end
end
hud.add(drawMinirank, game)
